unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Run1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Run1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;


var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.DFM}

//------------------------------------------------------------------------------
// ֐    EffectNOTMask
// pr      lK|V]
// 
//             hBMP             ...]TBitmap̃nh
//߂l@
//             rbg}bṽnh
// -----------------------------------------------------------------------------
function EffectNOTMask(hBMP: HBitmap):HBitmap;
var
  Row,Col          : Integer;
  SrcRow,DestRow   : pRGBArray;
  _Height,_Width   : integer;
  SrcBitmap,DestBitmap : TBitmap;
begin
 SrcBitmap   :=TBitmap.Create;
 DestBitmap  :=TBitmap.Create;
 SrcBitmap.Handle  :=hBMP;
 Set24bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

try
   For Row := 0 To _Height   do
   begin
       SrcRow:=SrcBitmap.ScanLine[Row];
       DestRow:=DestBitmap.ScanLine[Row];
        For Col := 0 To _Width do
        begin
             DestRow[Col].rgbtBlue := not SrcRow[Col].rgbtBlue ;
             DestRow[Col].rgbtGreen:= not SrcRow[Col].rgbtGreen;
             DestRow[Col].rgbtRed  := not SrcRow[Col].rgbtRed ;
       end;
    end;
  Result :=DestBitmap.ReleaseHandle;
except
   Result :=SrcBitmap.ReleaseHandle;
end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;

/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Image1.PIcture.Bitmap.LoadFromFIle(OpenDialog1.FIlename);
   Run1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.Run1Click(Sender: TObject);
begin
   Image1.Picture.bitmap.Handle:= EffectNOTMask(Image1.PIcture.Bitmap.ReleaseHandle);
end;

end.
